

- Fix an error-path file refcount leak

- Remove unnecessary get_file()/fput() pair.

- Clean up error handling a little


---

 25-akpm/drivers/block/loop.c |    9 ++-------
 1 files changed, 2 insertions(+), 7 deletions(-)

diff -puN drivers/block/loop.c~loop-fd-leak-fix drivers/block/loop.c
--- 25/drivers/block/loop.c~loop-fd-leak-fix	Wed Jan 14 14:42:55 2004
+++ 25-akpm/drivers/block/loop.c	Wed Jan 14 14:42:55 2004
@@ -676,7 +676,6 @@ static int loop_set_fd(struct loop_devic
 	if (!file)
 		goto out;
 
-	error = -EINVAL;
 	inode = file->f_dentry->d_inode;
 
 	if (!(file->f_mode & FMODE_WRITE))
@@ -686,7 +685,7 @@ static int loop_set_fd(struct loop_devic
 		lo_device = inode->i_bdev;
 		if (lo_device == bdev) {
 			error = -EBUSY;
-			goto out;
+			goto out_putf;
 		}
 		lo_blocksize = block_size(lo_device);
 		if (bdev_read_only(lo_device))
@@ -697,6 +696,7 @@ static int loop_set_fd(struct loop_devic
 		 * If we can't read - sorry. If we only can't write - well,
 		 * it's going to be read-only.
 		 */
+		error = -EINVAL;
 		if (!inode->i_fop->sendfile)
 			goto out_putf;
 
@@ -709,8 +709,6 @@ static int loop_set_fd(struct loop_devic
 	} else
 		goto out_putf;
 
-	get_file(file);
-
 	if (!(lo_file->f_mode & FMODE_WRITE))
 		lo_flags |= LO_FLAGS_READ_ONLY;
 
@@ -725,7 +723,6 @@ static int loop_set_fd(struct loop_devic
 	lo->lo_sizelimit = 0;
 	if (figure_loop_size(lo)) {
 		error = -EFBIG;
-		fput(file);
 		goto out_putf;
 	}
 	lo->old_gfp_mask = mapping_gfp_mask(inode->i_mapping);
@@ -760,8 +757,6 @@ static int loop_set_fd(struct loop_devic
 
 	kernel_thread(loop_thread, lo, CLONE_KERNEL);
 	down(&lo->lo_sem);
-
-	fput(file);
 	return 0;
 
  out_putf:

_
